/*
 * $Id: Action.java 93 2006-09-20 15:04:18Z k $
 * Copyright (C) 2006 Klaus Reimer <k@ailis.de>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

package de.ailis.wlandsuite.game.parts;

import java.io.IOException;

import org.dom4j.Element;

import de.ailis.wlandsuite.io.SeekableOutputStream;


/**
 * Action
 * 
 * @author Klaus Reimer (k@ailis.de)
 * @version $Revision: 93 $
 */

public interface Action
{
    /**
     * Writes the action data to the specified stream.
     * 
     * @param stream
     *            The stream to write the data to
     * @param specialActionTable
     *            The special action table
     * @throws IOException
     */

    public void write(SeekableOutputStream stream,
        SpecialActionTable specialActionTable) throws IOException;


    /**
     * Returns the action data as XML.
     * 
     * @param id
     *            The action id
     * @return The action data as XML
     */

    public Element toXml(int id);
}
